if(typeof(simianPlayLoaded) == "undefined")
{

var simianPlayLoaded = true;

// Detect Ipad	
var isiPad = navigator.userAgent.match(/iPad/i) != null;
var isiPhone = navigator.userAgent.match(/iPhone/i) != null;
var isChrome = navigator.userAgent.match(/Chrome/i) != null;
var isEdge = navigator.userAgent.match(/Edge/i) != null;
var isSafari = navigator.userAgent.match(/Safari/i) != null;
var isFirefox = navigator.userAgent.match(/Firefox/i) != null;

var isWindows = navigator.userAgent.match(/Windows/i) != null;

	
if(navigator.maxTouchPoints > 0 && !isWindows)
{
	isiPad = true;	
}
	
// The window beforeunload event may be triggered twice, but we want to handle only the first time.
var firstUnloadCall = true;
var windowUnloading = false;

// Default to using an asynchronous ajax call to track views.
var asyncVal = true;
 
var isBackend;	// leave as undefined
var vIdxForMicrosite = 0;  // needed for Iconic MS

var currentDuration = 0;
var currentTime = 0;
var startTime = 0;
var stopTime = 0;
var seeking = false;

// IE Specific Fun
var iePlaying = false;
var iePaused = false;
var ieScrubbed = false;
var ieEnd = false;
var ieTracked = false;

function stopAllVideo()
{
	$('#simianPlayer').simianVideoPlayer.pauseVideo();
}

function embedPlay(eid)
{
	if(eid != '')
	{
  		$('video').attr('poster','');
  		$('#simianPlayer').simianVideoPlayer.loadVideo(eid,true,0,0);
	}
}

function endVideo()
{
    // This is for embedded spots - so the parent window knows when the video is done
    // This helps the calling page know when to transition to the next video for embedded applications
    if(window.parent)
    {
       window.parent.postMessage('playbackComplete', '*');
    }
	$('.videoPlayer').addClass('is-paused');

	// check for presentation or preview
	// if isPreview is undefined, this is called from the backend.  Define isBackend.
	if(typeof(isPreview) == "undefined" && typeof(isBackend) == "undefined")
	{
		isPreview = false; 		// default to tracking views.  track_view() won't write the data if session variable not set.
		isBackend = true;
	}
	else if(typeof(isBackend) == "undefined")	// called from a presentation or preview
		isBackend = false;
	
	// used by approvals only, to advance to the next spot if the user has selected that option (preview or presentation)
	if((!isBackend && typeof(advance_media) == 'function') || typeof(autoAdvance) != 'undefined')
		advance_media();
		
	if(isPreview || isBackend)
		return;		// don't track previews or the backend
		
 	// Increment Full View
	//trackView('full', 100);
}


function playVideo(vidx, isMicrosite = false, aspectMask = true)
{
	// check for presentation or preview
	// if isPreview is undefined, this is called from the backend.  Define isBackend.
	if(typeof(isPreview) == "undefined" && typeof(isBackend) == "undefined")
	{
		isPreview = false; 		// default to tracking views.  track_view() won't write the data if session variable not set.
		isBackend = true;
	}
	else if(typeof(isBackend) == "undefined")	// called from a presentation or preview
		isBackend = false;
	
	// Force aspect mask for backend
	if(isBackend)
		aspectMask = true;
	
	disabledAutoPlay = true;
	
	if(typeof(forceAutoPlay) != "undefined")
		disabledAutoPlay = false;
	currentTime = 0;
	currentDuration = 0;	
	startTime = 0;
	stopTime = 0;
	vIdx = vidx;
	vIdxForMicrosite = vIdx;
	
	videoFile = videos[vidx];

	var thisAutoPlay = false;

	if(typeof(vPosters) != "undefined")
		$('.videoPlayer').html('<video id="simianPlayer" poster="' + vPosters[0] + '"><source src="' + videoFile + '" type="video/mp4"/></video>');
	else
		$('.videoPlayer').html('<video id="simianPlayer" poster="' + vThumbs[0] + '"><source src="' + videoFile + '" type="video/mp4"/></video>');
		
	if(isiPad)
	{
		if(isMicrosite && (isPreview || isBackend))
			$('#simianPlayer').simianVideoPlayer({theme: 'admin'});
		else if(isMicrosite)
			$('#simianPlayer').simianVideoPlayer({theme: 'admin',trackAnalytics:true, trackViewCallback:trackView, trackPartialCallback: trackPartial, endVideoCallback:endVideo});
		else if(isBackend)	
		{
			$('#simianPlayer').simianVideoPlayer({theme: 'project', gridOverlay: aspectMask, drawingTools: true, loopPlayback: true, frameControls: true, timeFormatControl: true, frameRate: vFrameRate, timeCodeOffset: vTimecodeOffset, timeStampComments: true});
			$('#video').show();
		}
		else if(isPreview)
			$('#simianPlayer').simianVideoPlayer({theme: 'project', gridOverlay: aspectMask, drawingTools: true, loopPlayback: true, frameControls: true, timeFormatControl: true, frameRate: vFrameRate, timeCodeOffset: vTimecodeOffset, timeStampComments: true, trackAnalytics:false});
		else // Front end player
			$('#simianPlayer').simianVideoPlayer({theme: 'project', gridOverlay: aspectMask, drawingTools: true, loopPlayback: true, frameControls: true, timeFormatControl: true, frameRate: vFrameRate, timeCodeOffset: vTimecodeOffset, timeStampComments: true, trackAnalytics:true, trackViewCallback:trackView, trackPartialCallback: trackPartial, endVideoCallback:endVideo});
	
		$('#gallery-spot').show();
		resizeContent();
		
	}
	else
	{
		if(isMicrosite && (isPreview || isBackend))
			$('#simianPlayer').simianVideoPlayer({theme: 'admin'});
		else if(isMicrosite)
			$('#simianPlayer').simianVideoPlayer({theme: 'admin',trackAnalytics:true, trackViewCallback:trackView, trackPartialCallback: trackPartial, endVideoCallback:endVideo});
		else if(isBackend)	
			$('#simianPlayer').simianVideoPlayer({theme: 'project', initializeCallback: function() {$.when($('#video').fadeIn()).done(function() {resizeContent();});}, gridOverlay: aspectMask, drawingTools: true, loopPlayback: true, frameControls: true, timeFormatControl: true, frameRate: vFrameRate, timeCodeOffset: vTimecodeOffset,timeStampComments: true});
		else if(isPreview)
			$('#simianPlayer').simianVideoPlayer({theme: 'project', initializeCallback: function() {$.when($('#gallery-spot').fadeIn()).done(function() {resizeContent();});}, gridOverlay: aspectMask, drawingTools: true, loopPlayback: true, frameControls: true, timeFormatControl: true, frameRate: vFrameRate, timeCodeOffset: vTimecodeOffset,timeStampComments: true, trackAnalytics:false});
		else // Front end player
			$('#simianPlayer').simianVideoPlayer({theme: 'project', initializeCallback: function() {$.when($('#gallery-spot').fadeIn()).done(function() {resizeContent();});}, gridOverlay: aspectMask, drawingTools: true, loopPlayback: true, frameControls: true, timeFormatControl: true, frameRate: vFrameRate, timeCodeOffset: vTimecodeOffset, timeStampComments: true, trackAnalytics:true, trackViewCallback:trackView, trackPartialCallback: trackPartial, endVideoCallback:endVideo});
	}
	
	if(typeof(load_after_comment) == 'function' && typeof loadPresentationComments === "function")
	{
		// Wait a sec to load the comments
		setTimeout(function(){ loadPresentationComments(); }, 500);
	}
	else if (typeof loadComments === "function") 
	{
		// Wait a sec to load the comments
		setTimeout(function(){ loadComments(); }, 500);
	}
}


function gotoTimeStamp(currSec)
{
	if($('#rangeComment').length > 0)
		return; // Can't do anything with range slider present
	
	if($('#audioPlayer').length > 0)
	{
		document.getElementById('audioPlayer').currentTime = currSec;
	}
	else
	{
		$('#simianPlayer').simianVideoPlayer.setCurrentTime(currSec);
	}
	
	if($('#prj_file_detail_select').val() != 'tab2')
	{
		$('#prj_file_detail_select option:eq(1)').prop('selected', true);
		$('.prj-fileDetail-tab').hide();
		$('#tab2').fadeIn();
		selectedTab =  $('#tab2').val();
	}
}


////////////////////////////////////////////////////////////
///   ANALYTICS
////////////////////////////////////////////////////////////

function trackListen(type, prct)
{
	// If this is from a reel, return since we're not tracking reel views in an approval
	if((typeof(bReel) != "undefined") && bReel == true)
		return;
		
	var en_projectID = $("#analytics_pid").val();
	var en_mediaID = $("#analytics_mid").val();
	var en_approvalID = $("#analytics_aid").val();
	var en_email = $("#analytics_email").val();
	var spot_type = $.trim($('#spot_file_type').text());
	var presentation_type = $.trim($('#pres_type').text());
	
	if(presentation_type == 'microsite')
	{
		if(en_projectID && en_mediaID)
		{
			$.ajax({
	  			url: base_url + 'sp/microsite/track_view/' + en_projectID + '/' +  en_mediaID + '/' + en_email + '/' + type + '/' + prct,
		  		async: asyncVal,
		  		success: function(data) {}
			});
		}
	}
	else
	{
		// Call track_view synchronously, to ensure tracking is written.
		if(en_projectID && en_mediaID && en_approvalID)
		{
			$.ajax({
		  		url: base_url + 'sp/approval/track_view/' + en_projectID + '/' +  en_mediaID + '/' + en_email + '/' + en_approvalID + '/' + type + '/' + prct,
			  	async: false,
		  		success: function(data) {}
			});
		}
	}
}

function trackPartialListen()
{
	
	if((typeof(isPreview) == "undefined" && typeof(isBackend) == "undefined") || !isPreview)
	{	
		var thePlayer = document.getElementById('audioPlayer');
	
		if(thePlayer)
		{
			ct = thePlayer.currentTime;	
			ft = thePlayer.duration;
			pv = (ct/ft) * 100;
			int_pv = Math.floor(pv);
	
			// Both Pause and End triggered at end of video, we don't want 2 100% views.
			if(int_pv < 100)
				trackListen('partial',  int_pv);	
		}
	}
}

function endAudio()
{
	if(typeof(isPreview) == "undefined" && typeof(isBackend) == "undefined")
	{
		var thePlayer = document.getElementById('audioPlayer');
	
		if(thePlayer)
		{
			trackListen('full',  100);
		}
	}
}

function trackView(type, prct, thisStartTime, thisStopTime)
{
	
	// don't track analytics for a spot in an embedded reel
	if(typeof(reel_ID) !== "undefined" && reel_ID !== null)
		return;
		
	// check for presentation or preview
	if(typeof(isPreview) == "undefined")
		isPreview = false; 		// default to tracking views.  track_view() won't write the data if session variable not set (or if backend)
		
	if(isPreview)
		return;		// don't track previews

	var en_projectID = $("#analytics_pid").val();
	var en_mediaID = $("#analytics_mid").val();
	var en_approvalID = $("#analytics_aid").val();
	var en_email = $("#analytics_email").val();
	var spot_type = $.trim($('#spot_file_type').text());
	var presentation_type = $.trim($('#pres_type').text());

	// Audio doesn't set start/stop time.  Add back when heatmaps are implemented.  cfw
	// if(spot_type == 'video' || spot_type == 'audio')
	
	if(spot_type == 'video' || spot_type == 'audio' || spot_type == 'video360')
	{
		thisStartTime = parseInt(thisStartTime);
		thisStopTime = parseInt(thisStopTime);
		// If this is a full view, we still need to record the view.  The startTime may not be set properly if it's the last spot in the reel.
		if((thisStartTime == thisStopTime) && type != 'full')
			return;
	}
	
	// Microsite or Approval?
	if(presentation_type == 'microsite')
	{
		if(en_projectID && en_mediaID)
		{
			// cfw fix code for heatmaps
			$.ajax({
	  			url: base_url + 'sp/microsite/track_view/' + en_projectID + '/' +  en_mediaID + '/' + en_email + '/' + type + '/' + prct,
		  		async: asyncVal,
		  		success: function(data) {}
			});
		}
	}
	else
	{
		if(en_projectID && en_mediaID && en_approvalID)
		{

			$.ajax({
		  		url: base_url + 'sp/approval/track_view/' + en_projectID + '/' +  en_mediaID + '/' + en_email + '/' + en_approvalID + '/' + type + '/' + prct,
		  		async: asyncVal,
		  		success: function(data) {}
			});
		}
	}
	
}

function trackPartial(duration, ctime, thisStartTime, thisStopTime)
{
	var spot_type = $.trim($('#spot_file_type').text());

	if(spot_type != 'video' && spot_type != 'audio' && spot_type != 'video360')
		return;
				
	if(duration > 0)
		pv = (ctime/duration) * 100;
	else
		pv = 0;
		
	int_pv = Math.floor(pv);

	// Both Pause and End triggered at end of video, we don't want 2 100% views.
	// Flowplayer can fire the pause and end events at 99%, so use that instead of 100.
	if(int_pv < 99)
	{
		trackView('partial',  int_pv, thisStartTime, thisStopTime);				
	}
}


// Set up unload listeners        
function initPresentationVideo()
{
	// check for presentation or preview
	// if isPreview is undefined, this is called from the backend.  Define isBackend.
	if(typeof(isPreview) == "undefined" && typeof(isBackend) == "undefined")
	{
		isPreview = false; 		// default to tracking views.  track_view() won't write the data if session variable not set.
		isBackend = true;
	}
	else if(typeof(isBackend) == "undefined")	// called from a presentation or preview
		isBackend = false;
	
	if(isPreview || isBackend)
		return;		// don't track previews or the backend
}

// Called from widescreen-04 after previous/next to set up listeners.
function setupPresentationVideo()
{
	// $(document).ready is triggered too early in the prev/next process for widescreen04, so need to call this.
	if($('#presentation_analytics').length > 0)
	{
		if($('#spot_file_type').length > 0 && ($.trim($('#spot_file_type').text())=='video' || $.trim($('#spot_file_type').text())=='audio')) {
			if(typeof(initPresentationVideo) =='function')
				initPresentationVideo();	// rebind listeners for unloading
		}
	}
}

function format_seconds(sec, remaining) {

   sec = Math.max(sec || 0, 0);
   sec = remaining ? Math.ceil(sec) : Math.floor(sec);

   var h = Math.floor(sec / 3600),
       min = Math.floor(sec / 60);

   sec = sec - (min * 60);

   if (h >= 1) {
      min -= h * 60;
      return h + ":" + zpad(min) + ":" + zpad(sec);
   }

   return zpad(min) + ":" + zpad(sec);
}

function zpad(val) {
   val = parseInt(val, 10);
   return val >= 10 ? val : "0" + val;
}


}