/* eslint-env browser */
/* global store, projects, Promise */

// TODO deprecated - don't add anything new here, and update existing code
var dataManager = (function () {

    function test() {
        console.warn("!!! [deprecated] dataManager call: test");
        __store.projectsAPI.checkSessionC();
    }

    function getFolders(projectObject, parentFolderId) {
        console.warn("!!! [deprecated] dataManager call: getFolders");
        __store.state.isLoadingFolders = true;
        __store.projectsAPI.getFoldersC(projectObject.id, parentFolderId, this._onProjectFoldersLoaded, projectObject);
    }

    function getFiles(projectObject, folderId) {
        console.warn("!!! [deprecated] dataManager call: getFiles");
        __store.state.isLoadingFiles = true;
        __store.projectsAPI.getFiles(projectObject.id, folderId, this._onUpdateProjectFiles, projectObject);
    }

    // function updateSubfolders(projectObject, folderObject, callback) {
    //     console.warn("!!! [deprecated] dataManager call: updateSubfolders");
    //     __store.projectsAPI.getFoldersC(projectObject.id, folderObject.id, this._onUpdateProjectFolders, folderObject);
    // }
    //
    // function updateFiles(projectObject, folderObject, callback) {
    //     console.warn("!!! [deprecated] dataManager call: updateFiles");
    //     __store.projectsAPI.getFiles(projectObject.id, folderObject.id, this._onUpdateProjectFiles, folderObject);
    // }

    function getComments(projectObject, fileObject) {
      console.warn("!!! [deprecated] dataManager call: getComments");
      console.log(":: Getting comments for p:"+projectObject.id+" f:"+fileObject.id);
        if(Object.keys(projects[projectObject.id].files[fileObject.id].comments).length < 1) {
            projects[projectObject.id].files[fileObject.id].isLoadingComments = true;
        }
        __store.projectsAPI.getComments(projectObject.id, fileObject.id, this._onCommentsLoaded, fileObject);
    }

    function addComment(project_id, file_id, comment) {
        console.warn("!!! [deprecated] dataManager call: addComment");
        __store.projectsAPI.addComment(project_id, file_id, comment, this._onAddCommentResponse);
    }

    function addReply(project_id, file_id, comment, reply_to_id) {
        console.warn("!!! [deprecated] dataManager call: addReply");
        __store.projectsAPI.addReply(project_id, file_id, comment, reply_to_id, this._onAddCommentResponse);
    }
    // callbacks - to be called with the folder object as 'this'
    function _onProjectFoldersLoaded(d, folder_id) {
        console.warn("!!! [deprecated] dataManager callback");
        console.log("::: _onProjectFoldersLoaded");
        __store.state.isLoadingFolders = false;
        var _this = this;
        console.log(_this);
        var f = d.root.payload;
        //console.log(f);
        f.forEach(function(item, index) {
            console.log("["+item.id+":"+item.name+"]");
            _this.folders[item.id] = (new Folder(item));
        });
        __store.eventHub.$emit('filebrowserUpdate');
    }

    function _onUpdateProjectFiles(data, folder_id) {
        console.warn("!!! [deprecated] dataManager callback");
        console.log("_onUpdateProjectFiles: " + folder_id);
        __store.state.isLoadingFiles = false;
        var _this = this;
        console.log(_this);
        var f = data.root.payload;
        //console.log(f);
        f.forEach(function(item, index) {
            console.log("["+item.id+":"+item.title+"]");
            _this.files[item.id] = (new File(item, folder_id));
        });
        __store.eventHub.$emit('filebrowserUpdate');
    }

    function _onCommentsLoaded(data) {
        console.warn("!!! [deprecated] dataManager callback");
        console.log("_onCommentsLoaded");
        var _this = this;
        console.log(_this);

        _this.isLoadingComments = false;
        var f = data.root.payload;
        //for (var cmt in _this.comments) delete _this.comments[cmt];

        console.log("::: INSERTING NEW COMMENTS");
        var newComments = [];
        f.forEach(function(item, index) {
            console.log("["+item.id+":"+item.comment+"]");
            newComments[item.id] = item;
            //__app.set(_this.comments, item.id, item);
        });
        newComments.sort(function(x, y){
          return new Date(x.start).getTime() - new Date(y.start).getTime()
        });
        _this.comments = newComments;
        console.log("::: UPDATED ARRAY:");
        console.log(_this.comments);
        __store.eventHub.$emit('commentsUpdate');
        //Vue.set(__store.FileView, 'comments', _this.comments);
        //FileView.$forceUpdate();

    }

    function _onAddCommentResponse() {
      console.warn("!!! [deprecated] dataManager callback: _onAddCommentResponse");
      var projectID = __store.state.projectID;
      var fileID = __store.state.fileID;
      dataManager.getComments(projects[projectID],projects[projectID].files[fileID]);
    }

    // end callbacks

    // public functions, including callbacks
    return {
        test: test,
        getFolders: getFolders,
        getFiles: getFiles,
        // updateSubfolders: updateSubfolders,
        // updateFiles: updateFiles,
        getComments: getComments,
        addComment: addComment,
        addReply: addReply,
        _onProjectFoldersLoaded: _onProjectFoldersLoaded,
        // _onUpdateProjectFolders: _onUpdateProjectFolders,
        _onUpdateProjectFiles: _onUpdateProjectFiles,
        _onCommentsLoaded: _onCommentsLoaded,
        _onAddCommentResponse: _onAddCommentResponse
    };

}());
/* eslint-env browser */
/* global Folder */
function Project(id, name) {
    this.id = id;
    this.name = name;

    this.root = new Folder({
        id: 0,
        name: "__ROOT__",
        project_id: this.id,
        parent: 0
    });

    this.folders = {};
    this.files = {};

    this.rootFoldersFetched = false;
    this.rootFilesFetched = false;

}

/* temp note: keep the update logic here, or move it to a data manager class? */
Project.prototype = {
    constructor:Project,
    getFolderById:function(f_id, base_folder, return_type) {
        var _this = this;
        var path = ["0"];
        var projId = this.id;
        var returnFolder = false;
        if (!base_folder)
        {
            //console.log('not base folders');
            base_folder = projects[projID].root;
        }
        console.log(':: Scanning folder '+base_folder.name);
        _.forEach(base_folder.folders, function(item) {
            if(returnFolder == false) {
                console.log(item.name + "(" + item.id + ")");
                if (item.folder_id == f_id) {
                    console.log('FOUND');
                    returnFolder = item;
                    path.push({fld_id: item.id, fld_name: item.name});
                    return;
                }
                else if (item.subfolderCount >= 1) {
                    path.push({fld_id: item.id, fld_name: item.name});
                    var ret = projects[projId].getFolderById(f_id, item);
                    if (ret != false)
                    {
                        returnFolder = ret;
                        return;
                    }
                }
            }
        });


        console.log("PATH:");
        console.log(path);
        if(return_type == 'path') {
            return path;
        }
        else {
            return returnFolder;
        }
    },
    getPathToFolder:function(f_id) {
//        var path = [];
//        var fld = this.getFolderById(f_id);
//
//        var thisFolderParentID = fld.parent;
//        var currFolderParentID = thisFolderParentID;
//
//        while(currFolderParentID > 0) {
//            console.log("current parent ID: " + currFolderParentID);
//            path.unshift(currFolderParentID);
//            var pFld = this.getFolderById()
//            pFld.parent;
//        }
//
//        path.unshift("0");
//        console.log(path);
//        return path;

    }
//    updateRootFolders:function() {
//        projectsAPI.getFolders(this.id, '', this._processFolderResponse, this);
//    },
//    updateRootFiles:function() {
//        projectsAPI.getFiles(this.id, '', this._processFileResponse, this);
//    },
//    _processFolderResponse:function(d) {
//        var _this = this;
//        var f = d.root.payload;
////        console.log(f);
//        f.forEach(function(item, index) {
//            console.log("["+item.id+":"+item.name+"]");
//            _this.root_folders[item.id] = (new Folder(item));
//        });
//    },
//    _processFileResponse:function(d) {
//        var _this = this;
//        var f = d.root.payload;
//        console.log(f);
//        f.forEach(function(item, index) {
//            console.log("["+item.id+":"+item.name+"]");
//            _this.root_files[item.id] = (new File(item));
//        });
//    },
//    setRootFolders:function(folderData) {
//
//        //TODO - tell the view to update?
//    }
};
function Folder(data) {
    this.id = parseInt(data.id);
    this.name = data.name;
    this.project_id = parseInt(data.project_id);
    if(data.parent.length < 1) {
        this.parent = 0;
    } else {
        this.parent = parseInt(data.parent);
    }

    this.subfolderCount = data.sub_folders;
    this.subfileCount = data.sub_files;

    this.folders = {};
    this.files = {};

    this.subfoldersFetched = false;
    this.filesFetched = false;

    this.loading = false;

    //console.log('folder constructor: ' + this.name + "(" + this.id + ")");
}

Folder.prototype = {
    constructor: Folder,
    isLoaded: function(){

    }
}
/* eslint-env browser */
function File(data, folderID) {
    this.id = parseInt(data.id);
    this.folderID = folderID;
    this.title = data.title;
    this.file_type = data.file_type;
    this.thumbnail = data.thumbnail;
    this.media_file = data.media_file;
    this.media_file_mobile = data.media_file;
    this.approval_status = data.approval_status;
    this.version_num = parseInt(data.version_num);
    this.version_parent_id = parseInt(data.version_parent_id);
    this.version_sort = parseInt(data.version_sort);
    this.commentCount = data.comments;
    this.comments = {};

    this.isLoadingComments = false;
}

File.prototype = {
    constructor:File
}
